local leftWin;
vCurrentHouseItem = nil;

--vType: 1 - Первый узел, 2 - конечный узел.     
function CreateHouseTreeNode(vCaption, vWidth, vHeight, vType)
  local vTreeNode = Turbine.UI.TreeNode();
  vTreeNode:SetSize(vWidth, vHeight);

  vTreeNode.Icon = Turbine.UI.Label();
  vTreeNode.Icon:SetParent(vTreeNode);
  vTreeNode.Icon:SetPosition(1, (vHeight-16)/2);
  vTreeNode.Icon:SetSize(16, 16);
  vTreeNode.Icon:SetVisible(true);
  vTreeNode.Icon:SetMouseVisible(false);
  
  vTreeNode.Caption = Turbine.UI.Label();
  vTreeNode.Caption:SetParent(vTreeNode);
  vTreeNode.Caption:SetSize(vWidth, vHeight);
  vTreeNode.Caption:SetPosition(23, 0);
  vTreeNode.Caption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
  vTreeNode.Caption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
  vTreeNode.Caption:SetForeColor(_G.clShadowWhite);
  vTreeNode.Caption:SetMouseVisible(false);
  vTreeNode.Caption:SetText("- "..vCaption);
  vTreeNode.Caption:SetVisible(true);
  if vType == 1 then
    vTreeNode.Caption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
    vTreeNode.Caption:SetText(vCaption);
  end;  
  
  if vType ~= 2 then 
    vTreeNode.HasChild = true;
    vTreeNode.MouseUp = function(sender, args)
      if sender.HasChild == true
        then if sender:IsExpanded()
          then 
            sender.Icon:SetBackground(vResPath.."treeM.tga")                
          else 
            sender.Icon:SetBackground(vResPath.."treeP.tga");                
          end;
      end;  
    end;
    vTreeNode.MouseLeave = function(sender, args)
      if sender.HasChild == true
        then if sender:IsExpanded()
          then 
            sender.Icon:SetBackground(vResPath.."treeM.tga")                
          else 
            sender.Icon:SetBackground(vResPath.."treeP.tga");                
          end;
      end;  
    end;  
  else
    vTreeNode.House = {};            
    vTreeNode.MouseClick = function(sender, args)
      if sender.HasChild == true
        then if sender:IsExpanded()
          then 
            sender.Icon:SetBackground(vResPath.."treeM.tga")                
          else 
            sender.Icon:SetBackground(vResPath.."treeP.tga");                
          end;
      end;
      if vCurrentHouseItem ~= nil then
         vCurrentHouseItem.Caption:SetForeColor(_G.clShadowWhite);
      end;    
      sender.Caption:SetForeColor(_G.clNiceGreen);    
      vCurrentHouseItem = sender;
      ResetHousePanel();
      BuildHouseInfoWin(_G.HousePanel, sender.House);
    end;
  end;  
  return vTreeNode;
end;

local function CreateChildNodesList(vParent)
  local vTreeList = vParent:GetChildNodes();
  vParent.Icon:SetBackground(vResPath.."treeP.tga");
  return vTreeList;  
end;

function BuildHouseTree(vLeftWin)
  leftWin = vLeftWin;
  
  tvHouse = Turbine.UI.TreeView();
  tvHouse:SetParent(leftWin);
  tvHouse:SetSize(270, leftWin:GetHeight()-20);
  tvHouse:SetPosition(5,5);
  tvHouse:SetIndentationWidth(-5);

  tvHouseSB = Turbine.UI.Lotro.ScrollBar();
  tvHouseSB:SetOrientation(Turbine.UI.Orientation.Vertical);
  tvHouseSB:SetParent(leftWin);
  tvHouseSB:SetPosition(265, 10);
  tvHouseSB:SetSize(10, leftWin:GetHeight()-20);

  tvHouse:SetVerticalScrollBar(tvHouseSB);
  
  FillTree_House();
end;

function FillTree_House()
  local nHouses = tvHouse:GetNodes();
  local Houses_len = #_G.Houses;
  local i;
  for i = 1, Houses_len do
    local nHouse = CreateHouseTreeNode(_G.Houses[i].TypeName, 270, 16, 1);
    nHouses:Add(nHouse);
    local nItems = CreateChildNodesList(nHouse) 
    local nItems_len = #_G.Houses[i].Items;
    local j;
    for j = 1, nItems_len do
      local nItem = CreateHouseTreeNode(_G.Houses[i].Items[j].ItemName, 260, 16, 2);    
      nItem.House = _G.Houses[i].Items[j];
      nItems:Add(nItem);
    end;
  end;
end;

function UpdateHouseTreePictures(vNodes)
  local tempNodes = vNodes
  if tempNodes == nil then
    tempNodes = tvHouse:GetNodes()
  end;
  local count_nodes = tempNodes:GetCount();
  for i = 1, count_nodes do
    if tempNodes:Get(i).HasChild == true then
      if tempNodes:Get(i):IsExpanded() then 
        tempNodes:Get(i).Icon:SetBackground(vResPath.."treeM.tga")                
      else 
        tempNodes:Get(i).Icon:SetBackground(vResPath.."treeP.tga");                
      end;
      UpdateHouseTreePictures(tempNodes:Get(i):GetChildNodes());
    end;
  end;  
end;
